#ifndef __AUD_CHAIN_ELEM_
#define __AUD_CHAIN_ELEM_

#include "PolyCommon.h"
#include "SimpleList.h"

class AudioChainElement
{
public:
  AudioChainElement(void);
  ~AudioChainElement(void);

public:
  SAMPLE getOutput(void);
  void tick(SAMPLE input);
  void endOfTick(void);
  // Connect this element to the given element
  void connectTo(AudioChainElement* element);
  void setGain(MyFloat64 gain){ m_gain = gain; };
  MyFloat64 getGain(void) { return m_gain; };

protected:
  // Each subclass generates the output samples using its own algorithm.
  //
  // Warning: The output returned by this function is NOT gain-adjusted.
  // The only caller of this function should be the tick() function.
  // All other users should use the getOutput() function to get the 
  // gain-adjusted output.
  virtual SAMPLE generateOutput(SAMPLE input) = 0;
  MyFloat64 m_gain;

private:
  bool m_visited;
  bool m_tickDone;
  SAMPLE m_nextTickInput;
  SAMPLE m_currentOutput;
  SimpleList m_outputList;
  
};


#endif //__AUD_CHAIN_ELEM_
