#ifndef __DELAY_FILTER_
#define __DELAY_FILTER_

#include "FIRFilter.h"

class DelayFilter : public FIRFilter
{
public:
  // What to load into the buffer upon initialization
  typedef enum LoadType {
    LOAD_ZERO = 0,
    LOAD_RANDOM = 1
  }LoadType;

  DelayFilter(int delay, int maxDelay, LoadType loadType = LOAD_ZERO);
  ~DelayFilter(void){}

public:
  // Child classes have their own algorithms for generating the output samples
  virtual SAMPLE generateOutput(SAMPLE input);
  // delay should not exceed maxDelay
  void changeDelay(int delay);

private:
  int m_delay;
};


#endif
