#ifndef __LIST_ITEM_
#define __LIST_ITEM_

#include <stdio.h>
#include <assert.h>

// A simple singly linked list of very limited functionality

// an item in a linked list
class ListItem {
public:
  // Constructor
  ListItem(void) { 
    m_pData = NULL;
    m_pNext = NULL;
  }

  ~ListItem(void) {
    delete m_pNext;
    // NOT responsible for deleting the Data!
  }

  // Setters and Getters
  inline void* getData(void) { return m_pData; }
  inline void setData(void* pData) { m_pData = pData; }

  inline ListItem* getNext(void) { return m_pNext; }
  inline void setNext(ListItem* pNext) { 
    // Sanity check: we probably aren't intending to break an existing link
    assert(m_pNext == NULL);
    m_pNext = pNext;
  }

private:
  void* m_pData;
  ListItem* m_pNext;
};



#endif //__LIST_ITEM_
