#ifndef __POLY_COMMON_
#define __POLY_COMMON_


#include <stdio.h>

// This files contains some basic definitions to be used
// throughout this project:
// - debug macros
// - basic data types


// Uncomment to enable debug prints
//#define POLY_DEBUG_ON
//#define DUMP_MIDI

// Define some common types
typedef double MyFloat64;
typedef unsigned int MyUint32;
typedef unsigned char MyUint8;

typedef MyFloat64 SAMPLE;


// Debug utilities
#ifdef POLY_DEBUG_ON
  #define DEBUG_PRINTF(x, ...)        do { printf(x, ## __VA_ARGS__); fflush(stdout); } while(0);
#else  
  #define DEBUG_PRINTF
#endif //POLY_DEBUG_ON

#ifdef DUMP_MIDI
  #define MIDI_DEBUG(x, ...)          do { printf(x, ## __VA_ARGS__); fflush(stdout); } while(0);
#else  
  #define MIDI_DEBUG
#endif //DUMP_MIDI


#endif //__POLY_COMMON_

